step_lincomb {recipes} | R Documentation

## Linear Combination Filter

### Description

`step_lincomb` creates a specification of a recipe step that will potentially remove numeric variables that have linear combinations between them.

### Usage

    step_lincomb(recipe, ..., role = NA, trained = FALSE, max_steps = 5,
      removals = NULL, skip = FALSE, id = rand_id("lincomp"))

    ## S3 method for class 'step_lincomb'
    tidy(x, ...)

### Arguments

`recipe` | A recipe object. The step will be added to the sequence of operations for this recipe.
`...` | One or more selector functions to choose which variables are affected by the step. See `selections()` for more details. For the `tidy` method, these are not currently used.
`role` | Not used by this step since no new variables are created.
`trained` | A logical to indicate if the quantities for preprocessing have been estimated.
`max_steps` | A value.
`removals` | A character string that contains the names of columns that should be removed. These values are not determined until `prep.recipe()` is called.
`skip` | A logical. Should the step be skipped when the recipe is baked by `bake.recipe()`? While all operations are baked when `prep.recipe()` is run, some operations may not be able to be conducted on new data (e.g. processing the outcome variable(s)). Care should be taken when using `skip = TRUE` as it may affect the computations for subsequent operations
`id` | A character string that is unique to this step to identify it.
`x` | A `step_lincomb` object.

### Details

This step finds exact linear combinations between two or more variables and recommends which column(s) should be removed to resolve the issue. This algorithm may need to be applied multiple times (as defined by `max_steps`).

### Value

An updated version of `recipe` with the new step added to the sequence of existing steps (if any). For the `tidy` method, a tibble with columns `terms` which is the columns that will be removed.

### Author(s)

Max Kuhn, Kirk Mettler, and Jed Wing

### See Also

step_nzv() `recipe()` `prep.recipe()` `bake.recipe()`

### Examples

    data(biomass)

    biomass$new_1 <- with(biomass,
                          .1*carbon - .2*hydrogen + .6*sulfur)
    biomass$new_2 <- with(biomass,
                          .5*carbon - .2*oxygen + .6*nitrogen)

    biomass_tr <- biomass[biomass$dataset == "Training",]
    biomass_te <- biomass[biomass$dataset == "Testing",]

    rec <- recipe(HHV ~ carbon + hydrogen + oxygen + nitrogen +
                    sulfur + new_1 + new_2,
                  data = biomass_tr)

    lincomb_filter <- rec %>%
      step_lincomb(all_predictors())

    lincomb_filter_trained <- prep(lincomb_filter, training = biomass_tr)
    lincomb_filter_trained

    tidy(lincomb_filter, number = 1)
    tidy(lincomb_filter_trained, number = 1)

[Package recipes version 0.1.5 Index]